﻿using UnityEngine;
//using UnityEditor;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class Control : MonoBehaviour {
	public static Control Instance;
	public static Player controlTarget;
	
	public Camera sceneCam;
	public Camera cam;
	public Transform camAxis;
	public Transform camTransform;
	public float horiztalSpd = 180;
	public float verticalSpd = 120;
	
	public float waveSize = 5;
	public float waveHeight = 5;
	
	public float[] skillcd = new float[]{1f,3f,5f,10f};
	public float[] skillTime = new float[]{0,0,0,0};
	
	private bool isJump = false;
	private bool isSandWalk = false;
	
	public void Begin() {
		sceneCam.gameObject.SetActive(false);
		cam.enabled = true;
	}
	
	
	
	void Awake() {
		Instance = this;
	}

	// Use this for initialization
	void Start () {
		
	}
	
	
	// Update is called once per frame
	// void Update () {
		// var plane = new Plane(Vector3.up, Vector3.zero);
		
		// Ray r = cam.ScreenPointToRay(Input.mousePosition);
		// float dis = 0;
		// plane.Raycast(r, out dis);
		// var point = r.GetPoint(dis);
		// var tp = OWTerrain.Instance.GetTerrainPoint(point);
		
		// Debug.DrawLine(transform.position, point);
		// Debug.DrawLine(tp.point, tp.point + Vector3.up * 5, Color.red);
		// Debug.DrawLine(tp.point, tp.point + tp.normal * 3, Color.yellow);
		
	
		// if(Input.GetKey(KeyCode.Q))
			// OWTerrain.Instance.SetWave(point,waveHeight, waveSize);
	// }
	
	
	private void SandWalk() {
		controlTarget.CmdSandWalk();
		StopAllCoroutines();
		StartCoroutine(ISandWalk());
	}
	
	private IEnumerator ISandWalk() {
		float t = 0;
		
		isSandWalk = true;
		
		while(t<Player.sandwalkTime) {
			t += Time.deltaTime;
			yield return null;
		}
		isSandWalk = false;
	}
	
	// Update is called once per frame
	void LateUpdate () {
		if(controlTarget == null)
			return;
			
		if(controlTarget.team == -1)
			return;
		
		var camMove = new Vector2();
		
		camMove.x = Input.GetAxis("Mouse X") * horiztalSpd * Time.deltaTime;
		camMove.y = Input.GetAxis("Mouse Y") * -verticalSpd * Time.deltaTime;
		
		transform.Rotate(Vector3.up * camMove.x);
		camAxis.Rotate(Vector3.right * camMove.y);
		
		transform.position = controlTarget.transform.position;
		
		if(Input.GetKeyDown(KeyCode.Alpha1) && skillTime[0] < 0.1f) {
			controlTarget.CmdFireSandImpact(transform.position, transform.rotation);
			skillTime[0] = skillcd[0];
		}
			
		if(Input.GetKeyDown(KeyCode.Alpha2) && skillTime[1] < 0.1f) {
			controlTarget.CmdSandJet(transform.position);	
			skillTime[1] = skillcd[1];
		}
		
		if(Input.GetKeyDown(KeyCode.Alpha3) && skillTime[2] < 0.1f) {
			SandWalk();
			skillTime[2] = skillcd[2];
		}
			
		if(Input.GetKeyDown(KeyCode.Alpha4) && skillTime[3] < 0.1f) {
			controlTarget.CmdSandWall(transform.position + transform.forward * 5f, transform.rotation);
			skillTime[3] = skillcd[3];
		}
		
		if(Input.GetKeyDown(KeyCode.Space))
			isJump = true;
			
		for(int i=0; i<skillTime.Length; i++) {
			skillTime[i] = Mathf.Max(skillTime[i]-Time.deltaTime,0);
		}
	}
	
	
	void FixedUpdate() {
		if(controlTarget == null)
			return;
		
		if(controlTarget.team == -1)
			return;
		
		var move = new Vector3();
		move.x = Input.GetAxis("Horizontal");
		move.z = Input.GetAxis("Vertical");
		
		if(isSandWalk) {
			move.z = 2f;
			var direction = transform.TransformDirection(move);
			float targetHeight = GetAveFrontHeight();
			direction.y = 0;
			direction = direction.normalized * Player.sandwalkSpeed;
			
			if(transform.position.y < targetHeight)
				direction.y = (targetHeight - transform.position.y) * 10f;
			
			Debug.DrawLine(transform.position, transform.position + Vector3.up * targetHeight);
			
			controlTarget.SandWalk(direction);
			controlTarget.Face(direction);
		}
		else {
			var direction = transform.TransformDirection(move);
			controlTarget.Run(direction);
			controlTarget.Face(direction);
		}
		
		
		
		if(isJump) {
			controlTarget.Jump();
			isJump = false;
		}
		
	}
	
	private float GetAveFrontHeight() {
		
		float h1 = OWTerrain.Instance.GetTerrainPoint(transform.position  + transform.forward).point.y;
		float h2 = OWTerrain.Instance.GetTerrainPoint(transform.position + transform.forward * 2).point.y;
		float h3 = OWTerrain.Instance.GetTerrainPoint(transform.position + transform.forward * 3).point.y;
		float h4 = OWTerrain.Instance.GetTerrainPoint(transform.position + transform.forward * 4).point.y;
		float h5 = OWTerrain.Instance.GetTerrainPoint(transform.position + transform.forward * 5).point.y;
		
		return (h1 + h2 + h3 + h4 + h5)/5f + 2;
	}
	
	
}

















