﻿using UnityEngine;
//using UnityEditor;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

public class SandImpact : MonoBehaviour {

	public float liftTime = 2.5f;
	
	public float speed = 20;
	public float strength = 4;
	public float size = 5;
	
	private float crtTime = 0;

	// Use this for initialization
	void Start () {
		// crtTime = liftTime;
	}
	
	// Update is called once per frame
	void Update () {
		crtTime += Time.deltaTime;
		
		transform.Translate(Vector3.forward * speed * Time.deltaTime);
		
		if(!GameManager.InsideGameArea(transform.position)) {
			Destroy(gameObject);
			return;
		}
		
		if(crtTime > liftTime) {
			Destroy(gameObject);
			return;
		}
		
		if(Ball.Instance != null) {
			float strength = Mathf.Clamp01(1 - Vector3.Distance(transform.position, Ball.Instance.transform.position) / 5f);
			Ball.Instance.AddForce(transform.position, transform.forward * 15 * strength);
		}
		
		var f = OWTerrain.Instance.GetTerrainPoint(transform.position).point.y * 0.5f;
		
		OWTerrain.Instance.SetWave(transform.position, Mathf.Min(crtTime*strength*2,strength) + f,Mathf.Min(crtTime*size*2,size));
	}
}
