﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SandWall : MonoBehaviour {
	
	public float liftTime = 0.75f;
	
	public float force = 7.5f;
	public float halfSize = 2.5f;
	
	public AnimationCurve curve = AnimationCurve.Linear(0,1,1,0);
	
	private float t = 0;
	
	// Use this for initialization
	void Start () {
		
	}
	
	// Update is called once per frame
	void LateUpdate () {
		
		t += Time.deltaTime;
		
		var precent = t/liftTime;
		var left = transform.position + transform.right * -halfSize;
		var right = transform.position + transform.right * halfSize;
		var f = force * curve.Evaluate(precent);
		
		for(int i = 0; i< 11; i++) {
			var pos = Vector3.Lerp(left, right, i/10f);
			OWTerrain.Instance.SetWave(pos,f, 1.25f);
			// OWTerrain.Instance.SetWave(pos,force, 1.25f);
		}
		
		if(t > liftTime)
			Destroy(gameObject);
		
	}
}
